"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.falseFn = exports.trueFn = exports.identity = exports.flat = exports.enyToGuardFn = exports.enyToGuard = exports.isValid = exports.assert = void 0;
const symbols_1 = require("./symbols");
const vality_1 = require("./vality");
function assert(val, condition) {
    if (condition === false) {
        throw new Error("Assertion failed");
    }
}
exports.assert = assert;
function isValid(data) {
    return data !== undefined;
}
exports.isValid = isValid;
function enyToGuard(eny) {
    // TODO: Fix this type mess -- I have no idea why it does that
    if (Array.isArray(eny)) {
        if (eny.length === 0)
            throw new Error("Empty array valit");
        // @ts-ignore
        if (eny.length === 1)
            return vality_1.vality.array(enyToGuard(eny[0]));
        // @ts-ignore
        return vality_1.vality.enum(...eny.map(enyToGuard));
    }
    // @ts-ignore
    if (typeof eny === "string" || typeof eny === "number" || typeof eny === "boolean" || eny === null)
        return vality_1.vality.literal(eny);
    // Not sure why we have to assert here, a symbol should never be a key in RSA
    // @ts-ignore
    if (symbols_1._validate in eny)
        return eny;
    // This should only allow () => RSE at this point...
    // @ts-ignore
    if (typeof eny === "function")
        return vality_1.vality.relation(eny);
    // Not sure why we have to assert here, as RSA should be the only type left after narrowing
    // @ts-ignore
    return vality_1.vality.object(eny);
}
exports.enyToGuard = enyToGuard;
// This type is too complicated to represent - should be ValidateFn<ParseIn<E>>
function enyToGuardFn(e) {
    return enyToGuard(e)[symbols_1._validate];
}
exports.enyToGuardFn = enyToGuardFn;
function flat(arr) {
    return [].concat(...arr);
}
exports.flat = flat;
function identity(x) {
    return x;
}
exports.identity = identity;
function trueFn(..._args) {
    return true;
}
exports.trueFn = trueFn;
function falseFn(..._args) {
    return false;
}
exports.falseFn = falseFn;
